
#ifndef _AUDIOCORERRR_
#define _AUDIOCORERRR_

#include <stdio.h>
#include <sys/time.h>

#include "asim/provides/low_level_platform_interface.h"
#include "asim/provides/funcp_simulated_memory.h"
#include "asim/provides/rrr.h"



typedef class AUDIOCORERRR_SERVER_CLASS* AUDIOCORERRR_SERVER;
class AUDIOCORERRR_SERVER_CLASS: public RRR_SERVER_CLASS, public PLATFORMS_MODULE_CLASS
{
  private:
    // self-instantiation
    static AUDIOCORERRR_SERVER_CLASS instance;
    FILE *outputFile;
    FUNCP_SIMULATED_MEMORY_CLASS *memory;   

     // server stub
    RRR_SERVER_STUB serverStub;

    int count;    

  public:
    AUDIOCORERRR_SERVER_CLASS();
    ~AUDIOCORERRR_SERVER_CLASS();

    // static methods
    static AUDIOCORERRR_SERVER GetInstance() { return &instance; }

    // required RRR methods
    void Init(PLATFORMS_MODULE);
    void Uninit();
    void Cleanup();

    //
    // RRR service methods
    //

   UINT32 MemoryRequestLoad  (UINT32 address);
   void   MemoryRequestStore (UINT32 address, UINT32 data);

   void   SendProcessedStream(UINT16 control, UINT16 data0);
};



// include server stub
#include "asim/rrr/server_stub_AUDIOCORERRR.h"

#endif
